"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runWebpack = void 0;
const webpack_1 = __importDefault(require("webpack"));
const errorFromStats = (stats) => {
    var _a;
    const errors = (_a = stats === null || stats === void 0 ? void 0 : stats.toJson()) === null || _a === void 0 ? void 0 : _a.errors;
    if (!errors) {
        return new Error("No stats");
    }
    return new Error("Error:" + errors.map((error) => error.message).join(", "));
};
const runWebpack = (options) => new Promise((resolve, reject) => {
    (0, webpack_1.default)(options, (err, stats) => {
        if (err) {
            reject(err);
        }
        else if ((stats === null || stats === void 0 ? void 0 : stats.hasErrors()) === false) {
            resolve(stats);
        }
        else {
            reject(errorFromStats(stats));
        }
    });
});
exports.runWebpack = runWebpack;
//# sourceMappingURL=test-utils.js.map