/**
 * Copyright (c) 2015-present, Waysact Pty Ltd
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import type { Compilation } from "webpack";
export declare class Reporter {
    /**
     * @internal
     */
    private compilation;
    /**
     * @internal
     */
    private emittedMessages;
    /**
     * @internal
     */
    constructor(compilation: Compilation);
    /**
     * @internal
     */
    private emitMessage;
    /**
     * @internal
     */
    private emitMessageOnce;
    /**
     * @internal
     */
    warnOnce(message: string): void;
    /**
     * @internal
     */
    errorOnce(message: string): void;
    /**
     * @internal
     */
    error(message: string): void;
    warnHotReloading(): void;
    warnContentHash(): void;
    warnNoAssetsFound(sourcePath: string, assetNames: string[]): void;
    errorCrossOriginLoadingNotSet(): void;
    warnStandardHashFuncs(): void;
    errorInvalidHashLoading(hashLoading: string, supportedHashLoadingOptions: readonly string[]): void;
    warnCrossOriginPolicy(): void;
    errorNonStringHashFunc(hashFuncName: unknown): void;
    errorUnusableHashFunc(hashFuncName: string, error: unknown): void;
    errorHashFuncsNonArray(hashFuncNames: unknown): void;
    errorHashFuncsEmpty(): void;
    warnNonWeb(): void;
    errorUnresolvedIntegrity(chunkFile: string): void;
}
//# sourceMappingURL=reporter.d.ts.map