import webpack from "webpack";
const errorFromStats = (stats) => {
    const errors = stats?.toJson()?.errors;
    if (!errors) {
        return new Error("No stats");
    }
    return new Error("Error:" + errors.map((error) => error.message).join(", "));
};
export const runWebpack = (options) => new Promise((resolve, reject) => {
    webpack(options, (err, stats) => {
        if (err) {
            reject(err);
        }
        else if (stats?.hasErrors() === false) {
            resolve(stats);
        }
        else {
            reject(errorFromStats(stats));
        }
    });
});
//# sourceMappingURL=test-utils.js.map