/**
 * Copyright (c) 2015-present, Waysact Pty Ltd
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import type { Compiler } from "webpack";
import { SubresourceIntegrityPluginOptions } from "./types";
/**
 * @public
 */
export { SubresourceIntegrityPluginOptions };
/**
 * The webpack-subresource-integrity plugin.
 *
 * @public
 */
export declare class SubresourceIntegrityPlugin {
    private readonly options;
    /**
     * Create a new instance.
     *
     * @public
     */
    constructor(options?: SubresourceIntegrityPluginOptions);
    /**
     * @internal
     */
    private isEnabled;
    /**
     * @internal
     */
    private setup;
    /**
     * @internal
     */
    private validateOptions;
    /**
     * @internal
     */
    private validateHashFuncNames;
    /**
     * @internal
     */
    private validateHashLoading;
    /**
     * @internal
     */
    private warnStandardHashFunc;
    /**
     * @internal
     */
    private validateHashFuncName;
    apply(compiler: Compiler): void;
}
//# sourceMappingURL=index.d.ts.map